Attribute VB_Name = "modDS"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const VT_BSTR = &H8&

Private Const CLSCTX_INPROC As Long = &H1&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&

' IAMCameraControl
Public Const KSPROPERTY_CAMERACONTROL_PAN As Long = 0
Public Const KSPROPERTY_CAMERACONTROL_TILT As Long = 1
Public Const KSPROPERTY_CAMERACONTROL_ROLL As Long = 2
Public Const KSPROPERTY_CAMERACONTROL_ZOOM As Long = 3
Public Const KSPROPERTY_CAMERACONTROL_EXPOSURE As Long = 4
Public Const KSPROPERTY_CAMERACONTROL_IRIS As Long = 5
Public Const KSPROPERTY_CAMERACONTROL_FOCUS As Long = 6
Public Const KSPROPERTY_CAMERACONTROL_SCANMODE As Long = 7
Public Const KSPROPERTY_CAMERACONTROL_PRIVACY As Long = 8
Public Const KSPROPERTY_CAMERACONTROL_PANTILT As Long = 9
Public Const KSPROPERTY_CAMERACONTROL_PAN_RELATIVE As Long = 10
Public Const KSPROPERTY_CAMERACONTROL_TILT_RELATIVE As Long = 11
Public Const KSPROPERTY_CAMERACONTROL_ROLL_RELATIVE As Long = 12
Public Const KSPROPERTY_CAMERACONTROL_ZOOM_RELATIVE As Long = 13
Public Const KSPROPERTY_CAMERACONTROL_EXPOSURE_RELATIVE As Long = 14
Public Const KSPROPERTY_CAMERACONTROL_IRIS_RELATIVE As Long = 15
Public Const KSPROPERTY_CAMERACONTROL_FOCUS_RELATIVE As Long = 16
Public Const KSPROPERTY_CAMERACONTROL_PANTILT_RELATIVE As Long = 17
Public Const KSPROPERTY_CAMERACONTROL_FOCAL_LENGTH As Long = 18
Public Const KSPROPERTY_CAMERACONTROL_AUTO_EXPOSURE_PRIORITY As Long = 19

' IAMVideoProcAmp
Public Const KSPROPERTY_VIDEOPROCAMP_BRIGHTNESS As Long = 0
Public Const KSPROPERTY_VIDEOPROCAMP_CONTRAST As Long = 1
Public Const KSPROPERTY_VIDEOPROCAMP_HUE As Long = 2
Public Const KSPROPERTY_VIDEOPROCAMP_SATURATION As Long = 3
Public Const KSPROPERTY_VIDEOPROCAMP_SHARPNESS As Long = 4
Public Const KSPROPERTY_VIDEOPROCAMP_GAMMA As Long = 5
Public Const KSPROPERTY_VIDEOPROCAMP_COLORENABLE As Long = 6
Public Const KSPROPERTY_VIDEOPROCAMP_WHITEBALANCE As Long = 7
Public Const KSPROPERTY_VIDEOPROCAMP_BACKLIGHT_COMPENSATION As Long = 8
Public Const KSPROPERTY_VIDEOPROCAMP_GAIN As Long = 9
Public Const KSPROPERTY_VIDEOPROCAMP_DIGITAL_MULTIPLIER As Long = 10
Public Const KSPROPERTY_VIDEOPROCAMP_DIGITAL_MULTIPLIER_LIMIT As Long = 11
Public Const KSPROPERTY_VIDEOPROCAMP_WHITEBALANCE_COMPONENT As Long = 12
Public Const KSPROPERTY_VIDEOPROCAMP_POWERLINE_FREQUENCY As Long = 13

Public Const IID_IBaseFilter As String = "{56a86895-0ad4-11ce-b03a-0020af0ba770}"
Public Const IID_IPropertyBag As String = "{55272a00-42cb-11ce-8135-00aa004bb851}"
Public Const IID_ICreateDevEnum As String = "{29840822-5b84-11d0-bd3b-00a0c911ce86}"
Public Const IID_IAMVideoProcAmp As String = "{c6e13360-30ac-11d0-a18c-00a0c9118956}"
Public Const IID_IAMCameraControl As String = "{c6e13370-30ac-11d0-a18c-00a0c9118956}"

Public Const IID_ISpecifyPropertyPages As String = "{b196b28b-bab4-101a-b69c-00aa00341d07}"
Public Const IID_IUnknown As String = "{00000000-0000-0000-c000-000000000046}"

Public Const CLSID_SystemDeviceEnum As String = "{62be5d10-60eb-11d0-bd3b-00a0c911ce86}"
Public Const CLSID_VideoInputDeviceCategory As String = "{860bb310-5d01-11d0-bd3b-00a0c911ce86}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    ' IUnknown
    QueryInterface = 0
    
    ' ICreateDevEnum
    CreateClassEnumerator = 3
    
    'IEnumMoniker
    Next_EM = 3
    Reset_EM = 5
    
    'IMoniker
    BindToObject = 8
    BindToStorage = 9
    
    ' IPropertyBag
    Read_PB = 3
    
    ' IAMCameraControl
    GetRange_CC = 3
    Set_CC = 4
    Get_CC = 5
    
    ' IAMVideoProcAmp
    GetRange_VPA = 3
    Set_VPA = 4
    Get_VPA = 5
    
    
    GetPages = 3
    QueryFilterInfo = 12
    
End Enum

Public Enum CameraControlProperty
    CameraControl_Pan = KSPROPERTY_CAMERACONTROL_PAN
    CameraControl_Tilt = KSPROPERTY_CAMERACONTROL_TILT
    CameraControl_Roll = KSPROPERTY_CAMERACONTROL_ROLL
    CameraControl_Zoom = KSPROPERTY_CAMERACONTROL_ZOOM
    CameraControl_Exposure = KSPROPERTY_CAMERACONTROL_EXPOSURE
    CameraControl_Iris = KSPROPERTY_CAMERACONTROL_IRIS
    CameraControl_Focus = KSPROPERTY_CAMERACONTROL_FOCUS
    LastCCIndex = CameraControl_Focus
End Enum


Public Enum CameraControlFlags
    CameraControl_Flags_Auto = &H1&
    CameraControl_Flags_Manual = &H2&
End Enum

Public Enum VideoProcAmpProperty
    VideoProcAmp_Brightness = KSPROPERTY_VIDEOPROCAMP_BRIGHTNESS
    VideoProcAmp_Contrast = KSPROPERTY_VIDEOPROCAMP_CONTRAST
    VideoProcAmp_Hue = KSPROPERTY_VIDEOPROCAMP_HUE
    VideoProcAmp_Saturation = KSPROPERTY_VIDEOPROCAMP_SATURATION
    VideoProcAmp_Sharpness = KSPROPERTY_VIDEOPROCAMP_SHARPNESS
    VideoProcAmp_Gamma = KSPROPERTY_VIDEOPROCAMP_GAMMA
    VideoProcAmp_ColorEnable = KSPROPERTY_VIDEOPROCAMP_COLORENABLE
    VideoProcAmp_WhiteBalance = KSPROPERTY_VIDEOPROCAMP_WHITEBALANCE
    VideoProcAmp_BacklightCompensation = KSPROPERTY_VIDEOPROCAMP_BACKLIGHT_COMPENSATION
    VideoProcAmp_Gain = KSPROPERTY_VIDEOPROCAMP_GAIN
    LastVPAIndex = VideoProcAmp_Gain
End Enum

Public Enum VideoProcAmpFlags
    VideoProcAmp_Flags_Auto = &H1&
    VideoProcAmp_Flags_Manual = &H2&
End Enum

' ----==== Type ====----
Public Type API_VARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type CAUUID
    cElems As Long
    pElems As Long
End Type

Public Type FilterInfo
    achName(127) As Byte
    pGraph As Long
End Type

' ----==== Kernel32 API-Deklarationen ====----
Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)

Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== OleAut32 API-Deklarationen ====----
Public Declare Function OleCreatePropertyFrame Lib "OleAut32.dll" ( _
                        ByVal hwndOwner As Long, _
                        ByVal x As Long, _
                        ByVal y As Long, _
                        ByVal lpszCaption As Long, _
                        ByVal cObjects As Long, _
                        ByVal ppUnk As Long, _
                        ByVal cPages As Long, _
                        ByVal pPageClsID As Long, _
                        ByVal lcid As Long, _
                        ByVal dwReserved As Long, _
                        ByVal pvReserved As Long) As Long
                        
Private Declare Function DispCallFunc Lib "OleAut32.dll" ( _
                    ByVal pvInstance As Long, _
                    ByVal oVft As Long, _
                    ByVal cc As Long, _
                    ByVal vtReturn As VbVarType, _
                    ByVal cActuals As Long, _
                    ByVal prgvt As Any, _
                    ByVal prgpvarg As Any, _
                    ByRef pvargResult As Variant) As Long

Public Declare Function VariantClear Lib "OleAut32.dll" ( _
                        ByRef pVar As API_VARIANT) As Long

' ----==== Ole32 API-Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)

Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pclsid As GUID) As Long

Private Declare Function CoCreateInstance Lib "Ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

' ----==== Create Interface ====----
Public Function CreateInterface(ByVal sCLSID As String, _
    ByVal sIID As String, ByRef pInterface As Long) As Boolean

    ' Interface erstellen
    If CoCreateInstance(VarPtr(Str2Guid(sCLSID)), 0&, CLSCTX_INPROC, _
        VarPtr(Str2Guid(sIID)), pInterface) = S_OK Then

        CreateInterface = True

    End If

End Function

' ----==== Release Interface ====----
Public Sub ReleaseInterface(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interface vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== Helper Function ====----
Public Function Str2Guid(ByVal sStr As String) As GUID

    If Len(sStr) > 0& Then

        Call CLSIDFromString(StrPtr(sStr), Str2Guid)
    
    End If
    
End Function

Public Function Ptr2String(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    lLen = lstrlenW(lpStrPointer) * 2 - 1

    If lLen > 0 Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        Ptr2String = bBuffer

    End If

End Function

